OUTPUT_FORMAT("elf32-littleriscv")
ENTRY(_start)

MEMORY
{
    rom :
 ORIGIN = 0x00000000,
 LENGTH = 4096
    bss :
 ORIGIN = 0x00040000,
 LENGTH = 1024

 /* Sorry, but there is no initialized ram.  */
   empty :
 ORIGIN = 0x000e0000,
 LENGTH = 0
}

SECTIONS
{
 .text : { *(.boot) *(.text .text.*) } > rom =0
 .rodata : {
   *(.rodata .rodata.*);
   . = ALIGN(4);
 } > rom =0

 .data : { *(.data .data.*) } > empty

 _gp = . + 0x800;

 .bss : {
  . = . + 4;
  *(.sbss .sbss.*)
  *(.bss .bss.*)
  *(COMMON)
  . = ALIGN(4);
  _end = .;
  . = . + 16;
  _regs = .;
  . = . + 32*4;
  _sstack = .;
 } > bss

 /DISCARD/ : { *(.riscv.attributes) }

 _fstack = ORIGIN(bss) + LENGTH(bss) - 4;
}
